Subject: Re: bug#46797: mac_font_shape EXC_BAD_ACCESS

From: Jimmy Yuen Ho Wong <[email-masked]>
Date: Sat, 27 Feb 2021 05:07:31 +0000

All I did was type really fast under emacs-lisp-mode that has company
and company-box setup, I just typed faster than company was able to
show me a completion menu.

Like many emacs crashes and hangs, I have no way of reproducing them
consistently. Given there's not even an lldbinit written, I can't even
debug it effectively. All I can do is run emacs compiled with
debugging information under lldb.

Jimmy

On Fri, Feb 26, 2021 at 7:03 PM Alan Third <[email-masked]> wrote:
>
> On Fri, Feb 26, 2021 at 04:30:13PM +0000, Jimmy Yuen Ho Wong wrote:
> > Emacs crash on the NSPort of emacs27 HEAD, here's the LLDB info:
> >
> > Process 94921 stopped
> > * thread #1, queue = 'com.apple.main-thread', stop reason =
> > EXC_BAD_ACCESS (code=1, address=0x7ffeefc00000)
> >     frame #0: 0x00000001003abd3a
> > Emacs`mac_font_shape(font=0x000000011fb480c0, string=@"𝆺𝅥𝅯𝉂\0\0\0\0",
> > glyph_layouts=0x00007ffeefbe9a50, glyph_len=8, dir=DIR_UNKNOWN) at
> > macfont.m:3754:34
> >    3751               struct mac_glyph_layout *gl =
> >    3752                 glbuf + range.location + range.length;
> >    3753
> > -> 3754               if (gl->comp_range.length
> >    3755                   > comp_range.location + comp_range.length)
> >    3756                 comp_range.length = gl->comp_range.length -
> > comp_range.location;
> >    3757               min_location = gl->comp_range.location;
> > Target 0: (Emacs) stopped.
> > (lldb) bt --all
> > error: bt [<digit> | all]
> > (lldb) bt all
> > * thread #1, queue = 'com.apple.main-thread', stop reason =
> > EXC_BAD_ACCESS (code=1, address=0x7ffeefc00000)
> >   * frame #0: 0x00000001003abd3a
> > Emacs`mac_font_shape(font=0x000000011fb480c0, string=@"𝆺𝅥𝅯𝉂\0\0\0\0",
> > glyph_layouts=0x00007ffeefbe9a50, glyph_len=8, dir=DIR_UNKNOWN) at
> > macfont.m:3754:34
> >     frame #1: 0x00000001003a529e
> > Emacs`macfont_shape(lgstring=0x0000000106e2f005,
> > direction=0x0000000000000000) at macfont.m:3000:16
>
> The interesting bit here is missing.
>
> Can you repeat the crash and give us a recipe?
> --
> Alan Third